﻿;https://purebasic.mybb.ru/viewtopic.php?id=99
; Компилятор : Pure Basic 4.50
Global myfont
If(OpenLibrary(0, "GDI32.DLL"))
  myfont=CallFunction(0, "AddFontMemResourceEx", ?fs, (?fe -?fs), 0, @i +1) 
  CloseLibrary(0)
Else
  MessageRequester("E.R.R.O.R.","GDI32.DLL problem...") 
  End 
EndIf

Procedure loadtext(f$)
  fs=FileSize(f$)
  If fs>0
    *m=AllocateMemory(fs)
    If *m
      If ReadFile(0,f$)
        ReadData(0,*m,fs)
        CloseFile(0)
        s$=PeekS(*m,fs,#PB_Ascii)
        s$=ReplaceString(s$,Chr($0A),#CRLF$)
        s$=ReplaceString(s$,Chr($0D)+Chr($0D),Chr($0D))
        SetGadgetText(0,s$)
        FreeMemory(*m)
      Else
        MessageRequester("file error","cannot read"+#CRLF$+f$) 
      EndIf
    Else
      MessageRequester("memory error","cannot allocate for"+#CRLF$+f$) 
    EndIf
    
  Else
    MessageRequester("file error","cannot read"+#CRLF$+f$) 
  EndIf
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, "ammy ascii",#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_MinimizeGadget)
  
  ;LoadFont(1, "TopazPlus a600a1200a4000", 16)
  LoadFont(1, "Topaz a500a1000a2000 v1.0", 12)
  SetGadgetFont(#PB_Default, FontID(1))
  StringGadget(0, 0, 0, 640, 480,"Ammy ASCII by g0blinish",#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ES_WANTRETURN)
  SetGadgetColor(0,#PB_Gadget_BackColor,RGB(170,170,170))
  
  EnableGadgetDrop(0,#PB_Drop_Files,#PB_Drag_Copy)
  
  ;f$="nup-tptp.txt"
  ;f$="znr-evoke2017.txt"
  ;f$="sundown2012-zs.txt"
  ;loadtext("sundown2012-zs.txt")
  If CountProgramParameters()
    loadtext(ProgramParameter(0))
  EndIf
  
  Repeat
    eve=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    Select eve
      Case #PB_Event_GadgetDrop 
        F$ = EventDropFiles()
        loadtext(StringField(F$, 1, Chr(10)))
    EndSelect
  Until eve = #PB_Event_CloseWindow
  
EndIf

FreeFont(1)
RemoveFontMemResourceEx_(myfont)

DataSection
  fs:
  ;IncludeBinary("topazplus120010.ttf")
  IncludeBinary("Topaz_a500_v1.0.fon")
  fe:
EndDataSection
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 76
; FirstLine = 36
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = ammya.ico
; Executable = ammyascii.exe
; CommandLine = nup-tptp.txt